;;;********************************************************************
;;;           
;;;        VNP.LSP v.3
;;;        Copyright,1993-99        ..
;;;         AutoCAD for Windows 05.05.99
;;;        E-Mail: nest@mail.ru
;;;          .. 23.07.2003
;;;        command: ^C^C(load "vnp3") vnp3
;;;;*******************************************************************
(defun c:vnp3 (/       p1      p2      p3      x1      x2      obj
	       ch      sc      r       h       tg      wt      NewLayer
	       olderr  old_cmd old_blip	       old_txt old_clr old_os
	      )

  (setq	olderr	*error*			; Initialize variables
	*error*	prerr
  )

  ;; "1" -  1  ""   
  (setq NewLayer "1")
  (if (null (tblsearch "LAYER" NewLayer))
    (command "_LAYER" "_N" NewLayer "")
  )

  ;;          
  (setq	old_cmd	 (getvar "CMDECHO")	;save current configuration
	old_blip (getvar "BLIPMODE")
	old_clr	 (getvar "CLAYER")
	old_os	 (getvar "OSMODE")
  )
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setvar "OSMODE" 0)
  (setvar "CLAYER" NewLayer)

  (setq p1 (getpoint "\n   : "))
  (setvar "OSMODE" 512) ;  - ,  - 0  

  (setq p2 (getpoint p1 "\n   : "))
  (setvar "OSMODE" 0)

  (setq	x1 (car p1)
	x2 (car p2)
  )

  (setq sc (getvar "DIMSCALE"))		;   
  (if (= sc 0.0)
    (setq sc 1.0)
  )
;;;  ,  ,       
  (setq	r  (* 0.35 sc (getvar "DIMASZ"))
	h  (* sc (getvar "DIMTXT"))
	tg (* sc (getvar "DIMGAP"))
  )
  (command "DONUT" 0 r p1 "")
  (command "LINE" p1 p2 "")

  (setq ch (getstring "\n  : "))
  (if (= ch "")
    (setq ch nil)
  )

  (while ch
    (setq p3 (polar p2 (/ pi 2) tg))
    (if	(<= x1 x2)
      (progn
	(setq p3 (polar p3 0.0 (* 1.5 tg)))
					; 1.5-     . 
	(command "TEXT" p3 h 0 ch)
      )
      (progn
	(setq p3 (polar p3 pi (* 1.5 tg)))
	(command "TEXT" "J" "R" p3 h 0 ch)
      )
    )
    (setq obj (entget (entlast))
	  tb  (textbox obj)
	  wt  (car (cadr tb))		;  
    )
    (setq wt (+ wt (* 2.3 tg)))		; 2.5=1.5+0.8 -    
    (if	(<= x1 x2)
      (setq p1 (polar p2 0.0 wt))
      (setq p1 (polar p2 pi wt))
    )
    (command "LINE" p2 p1 "")

    (setq ch (getstring "\n  : "))
    (if	(= ch "")
      (setq ch nil)
      (progn
	(setq p1 (polar p2 (* 1.5 pi) (* sc 8.0)))
					; 8.0-  
	(command "LINE" p2 p1 "")
	(setq p2 p1)
      )
    )
  ) ;_end while ch

  (setvar "CMDECHO" old_cmd)
  (setvar "BLIPMODE" old_blip)
  (setvar "OSMODE" old_os)
  (setvar "CLAYER" old_clr)
  (command "REDRAW")

  (setq *error* olderr)			; Rest ore old *error* handler
  (princ)
) ;_end